using System.Text.Json;
using System.Text.Json.Serialization;

namespace Mesa_Backlog.Library;

public class AppSettings
{

    public string Company { init; get; }
    public Client Client { init; get; }
    public Excel Excel { init; get; }
    public string WorkingDirectoryName { init; get; }
    public string URLs { init; get; }

    [JsonConstructor]
    public AppSettings(Client client, string company, Excel excel, string workingDirectoryName, string urls)
    {
        Client = client;
        Company = company;
        Excel = excel;
        WorkingDirectoryName = workingDirectoryName;
        URLs = urls;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}