using System.Text.Json;
using System.Text.Json.Serialization;

namespace Mesa_Backlog.Library;

public class Client
{

    public string API { init; get; }
    public string BaseAddress { init; get; }
    public string BasePage { init; get; }
    public string PAT { init; get; }
    public string Project { init; get; }
    public string Query { init; get; }

    [JsonConstructor]
    public Client(
        string api,
        string baseAddress,
        string basePage,
        string pat,
        string project,
        string query
    )
    {
        API = api;
        BaseAddress = baseAddress;
        BasePage = basePage;
        PAT = pat;
        Project = project;
        Query = query;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}