using System.Text.Json.Serialization;

namespace Mesa_Backlog.Library.WorkItems;

public class Fields
{
    [JsonConstructor]
    public Fields(string systemAreaPath,
        string systemTeamProject,
        string systemIterationPath,
        string systemWorkItemType,
        string systemState,
        string systemReason,
        User systemAssignedTo,
        DateTime systemCreatedDate,
        User systemCreatedBy,
        DateTime systemChangedDate,
        User systemChangedBy,
        int systemCommentCount,
        string systemTitle,
        string systemBoardColumn,
        bool systemBoardColumnDone,
        DateTime microsoftVSTSCommonStateChangeDate,
        DateTime microsoftVSTSCommonActivatedDate,
        User microsoftVSTSCommonActivatedBy,
        DateTime microsoftVSTSCommonResolvedDate,
        User microsoftVSTSCommonResolvedBy,
        DateTime microsoftVSTSCommonClosedDate,
        User microsoftVSTSCommonClosedBy,
        int microsoftVSTSCommonPriority,
        double microsoftVSTSSchedulingEffort,
        DateTime microsoftVSTSSchedulingTargetDate,
        double microsoftVSTSCommonStackRank,
        string microsoftVSTSCommonValueArea,
        string microsoftVSTSTCMSystemInfo,
        string wEF81590F0A22C04FEF834957660F5F0C58KanbanColumn,
        bool wEF81590F0A22C04FEF834957660F5F0C58KanbanColumnDone,
        string systemDescription,
        string systemHistory,
        string systemTags,
        string href)
    {
        SystemAreaPath = systemAreaPath;
        SystemTeamProject = systemTeamProject;
        SystemIterationPath = systemIterationPath;
        SystemWorkItemType = systemWorkItemType;
        SystemState = systemState;
        SystemReason = systemReason;
        SystemAssignedTo = systemAssignedTo;
        SystemCreatedDate = systemCreatedDate;
        SystemCreatedBy = systemCreatedBy;
        SystemChangedDate = systemChangedDate;
        SystemChangedBy = systemChangedBy;
        SystemCommentCount = systemCommentCount;
        SystemTitle = systemTitle;
        SystemBoardColumn = systemBoardColumn;
        SystemBoardColumnDone = systemBoardColumnDone;
        MicrosoftVSTSCommonStateChangeDate = microsoftVSTSCommonStateChangeDate;
        MicrosoftVSTSCommonActivatedDate = microsoftVSTSCommonActivatedDate;
        MicrosoftVSTSCommonActivatedBy = microsoftVSTSCommonActivatedBy;
        MicrosoftVSTSCommonClosedBy = microsoftVSTSCommonClosedBy;
        MicrosoftVSTSCommonClosedDate = microsoftVSTSCommonClosedDate;
        MicrosoftVSTSCommonPriority = microsoftVSTSCommonPriority;
        MicrosoftVSTSCommonResolvedBy = microsoftVSTSCommonResolvedBy;
        MicrosoftVSTSCommonResolvedDate = microsoftVSTSCommonResolvedDate;
        MicrosoftVSTSCommonStackRank = microsoftVSTSCommonStackRank;
        MicrosoftVSTSCommonValueArea = microsoftVSTSCommonValueArea;
        MicrosoftVSTSSchedulingEffort = microsoftVSTSSchedulingEffort;
        MicrosoftVSTSSchedulingTargetDate = microsoftVSTSSchedulingTargetDate;
        MicrosoftVSTSTCMSystemInfo = microsoftVSTSTCMSystemInfo;
        WEF81590F0A22C04FEF834957660F5F0C58KanbanColumn = wEF81590F0A22C04FEF834957660F5F0C58KanbanColumn;
        WEF81590F0A22C04FEF834957660F5F0C58KanbanColumnDone = wEF81590F0A22C04FEF834957660F5F0C58KanbanColumnDone;
        SystemDescription = systemDescription;
        SystemHistory = systemHistory;
        SystemTags = systemTags;
        Href = href;
    }

    [JsonPropertyName("System.AreaPath")]
    public string SystemAreaPath { init; get; }

    [JsonPropertyName("System.TeamProject")]
    public string SystemTeamProject { init; get; }

    [JsonPropertyName("System.IterationPath")]
    public string SystemIterationPath { init; get; }

    [JsonPropertyName("System.WorkItemType")]
    public string SystemWorkItemType { init; get; }

    [JsonPropertyName("System.State")]
    public string SystemState { init; get; }

    [JsonPropertyName("System.Reason")]
    public string SystemReason { init; get; }

    [JsonPropertyName("System.AssignedTo")]
    public User SystemAssignedTo { init; get; }

    [JsonPropertyName("System.CreatedDate")]
    public DateTime SystemCreatedDate { init; get; }

    [JsonPropertyName("System.CreatedBy")]
    public User SystemCreatedBy { init; get; }

    [JsonPropertyName("System.ChangedDate")]
    public DateTime SystemChangedDate { init; get; }

    [JsonPropertyName("System.ChangedBy")]
    public User SystemChangedBy { init; get; }

    [JsonPropertyName("System.CommentCount")]
    public int SystemCommentCount { init; get; }

    [JsonPropertyName("System.Title")]
    public string SystemTitle { init; get; }

    [JsonPropertyName("System.BoardColumn")]
    public string SystemBoardColumn { init; get; }

    [JsonPropertyName("System.BoardColumnDone")]
    public bool SystemBoardColumnDone { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.StateChangeDate")]
    public DateTime MicrosoftVSTSCommonStateChangeDate { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ActivatedDate")]
    public DateTime MicrosoftVSTSCommonActivatedDate { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ActivatedBy")]
    public User MicrosoftVSTSCommonActivatedBy { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ResolvedDate")]
    public DateTime MicrosoftVSTSCommonResolvedDate { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ResolvedBy")]
    public User MicrosoftVSTSCommonResolvedBy { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ClosedDate")]
    public DateTime MicrosoftVSTSCommonClosedDate { get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ClosedBy")]
    public User MicrosoftVSTSCommonClosedBy { get; }

    [JsonPropertyName("Microsoft.VSTS.Common.Priority")]
    public int MicrosoftVSTSCommonPriority { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Scheduling.Effort")]
    public double MicrosoftVSTSSchedulingEffort { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Scheduling.TargetDate")]
    public DateTime MicrosoftVSTSSchedulingTargetDate { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.StackRank")]
    public double MicrosoftVSTSCommonStackRank { init; get; }

    [JsonPropertyName("Microsoft.VSTS.Common.ValueArea")]
    public string MicrosoftVSTSCommonValueArea { init; get; }

    [JsonPropertyName("Microsoft.VSTS.TCM.SystemInfo")]
    public string MicrosoftVSTSTCMSystemInfo { init; get; }

    [JsonPropertyName("WEF_81590F0A22C04FEF834957660F5F0C58_Kanban.Column")]
    public string WEF81590F0A22C04FEF834957660F5F0C58KanbanColumn { init; get; }

    [JsonPropertyName("WEF_81590F0A22C04FEF834957660F5F0C58_Kanban.Column.Done")]
    public bool WEF81590F0A22C04FEF834957660F5F0C58KanbanColumnDone { init; get; }

    [JsonPropertyName("System.Description")]
    public string SystemDescription { init; get; }

    [JsonPropertyName("System.History")]
    public string SystemHistory { init; get; }

    [JsonPropertyName("System.Tags")]
    public string SystemTags { init; get; }

    public string Href { init; get; }
}