using Mesa_Backlog.Library;
using Microsoft.Extensions.Configuration;
using Serilog;
using System.Reflection;

namespace Mesa_Backlog.Tests;

[TestClass]
public class AA_UnitTestExample
{

    private readonly ILogger _Logger;
    private readonly AppSettings _AppSettings;
    private readonly string _WorkingDirectory;
    private readonly IConfigurationRoot _ConfigurationRoot;

    public AA_UnitTestExample()
    {
        ILogger logger;
        AppSettings appSettings;
        string workingDirectory;
        IConfigurationRoot configurationRoot;
        LoggerConfiguration loggerConfiguration = new();
        Assembly assembly = Assembly.GetExecutingAssembly();
        IConfigurationBuilder configurationBuilder = new ConfigurationBuilder()
            .AddEnvironmentVariables()
            .AddJsonFile("appsettings.Development.json");
        configurationRoot = configurationBuilder.Build();
        appSettings = Library.Binder.AppSettings.Get(configurationRoot);
        workingDirectory = IWorkingDirectory.GetWorkingDirectory(assembly.GetName().Name, appSettings.WorkingDirectoryName);
        Environment.SetEnvironmentVariable(nameof(workingDirectory), workingDirectory);
        _ = ConfigurationLoggerConfigurationExtensions.Configuration(loggerConfiguration.ReadFrom, configurationRoot);
        Log.Logger = loggerConfiguration.CreateLogger();
        logger = Log.ForContext<AA_UnitTestExample>();
        logger.Information("Complete");
        _Logger = logger;
        _AppSettings = appSettings;
        _WorkingDirectory = workingDirectory;
        _ConfigurationRoot = configurationRoot;
    }

    [TestMethod]
    public void TestMethodNull()
    {
        Assert.IsFalse(_Logger is null);
        Assert.IsFalse(_AppSettings is null);
        Assert.IsFalse(_WorkingDirectory is null);
        Assert.IsFalse(_ConfigurationRoot is null);
        Assert.IsFalse(string.IsNullOrEmpty(_AppSettings.ToString()));
    }

}